#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
main(int argc, char **argv)
{
	int offset = 0xde;
	char buf[4];
	long res;
	long fd;

	if (argc != 2) {
	   fprintf(stderr, "Usage: locklib <lib.so>\n");
	   exit(1);
	}

	fd = open(argv[1], O_RDWR);

	if (fd < 0) {
	   perror("locklib");
	   exit(1);
	}

	lseek (fd, 0, SEEK_SET);
	res = read(fd, buf, 2);

	if (res != 2) {
	   perror("locklib");
	   exit(1);
	}

	if (buf[0] != 'M' || buf[1] != 'Z') {
	   fprintf(stderr, "File is not PE\n");
	   exit(1);
	}

	lseek (fd, 0x80, SEEK_SET);

	res = read(fd, buf, 2);

	if (res != 2) {
	   perror("locklib");
	   exit(1);
	}

	if (buf[0] != 'P' || buf[1] != 'E') {
	   fprintf(stderr, "File is not PEI\n");
	   exit(1);
	}

	lseek (fd, offset, SEEK_SET);

	res = read(fd, buf, 1);

	if (res != 1) {
	   perror("locklib");
	   exit(1);
	}

	if (buf[0] != 1) {
	   fprintf(stderr, "File is not unlocked shared lib\n");
	   exit(1);
	}

	lseek (fd, offset, SEEK_SET);

	buf[0] = 3;
	res = write(fd, buf, 1);

	if (res != 1) {
	   perror("locklib");
	   exit(1);
	}

	exit(0);
}
