#!/bin/ksh

#
# Script to create a gcc-src.tgz file
# (gzip'd tarfile) that contains the gcc sources
# used in Interix
#

set -x

rm -f /tmp/gcc-srclist; touch /tmp/gcc-srclist;
sdi files -d ... >> /tmp/gcc-srclist

# make sure srclist is in UNIX format
#
flip -u /tmp/gcc-srclist

chmod +w gcc-src.list	# make sure srclist file is writeable

#
# filter off 
#  a) all the SD crud output
#  b) and remove the files in 'testsuite/fcvs/'
#     Because this stuff is from NIST and we don't really want
#     to distribute that
#  c) and any blank lines
#
if [ "$?" = 0 ]; then 			\
  sed -e 's;//depot/Main/;;' 		\
      -e 's;\#.*;;'		 	\
      -e 's;.*/testsuite/fcvs/[^R].*;;' \
      -e '/^$/d'                        \
    < /tmp/gcc-srclist > gcc-src.list;  \
fi

pax -wf - < gcc-src.list | gzip > gcc-src.tgz
