# Linker script for PE.
if [ "x${RELOCATING}" = x ]
then
   OUTPUT_FORMAT=${LINK_FORMAT} :
fi

LINKERSECTS="${RELOCATING-0} ${RELOCATXXX+\(NOLOAD\)} ${RELOCATING+ BLOCK(__section_alignment__) }"

cat <<EOF
OUTPUT_FORMAT(${OUTPUT_FORMAT})
${LIB_SEARCH_DIRS}

ENTRY(${ENTRY})

/* if DYNAMIC_LINKING [ */
/* Not sure yet */
${RELOCATING+/* Do we need any of these for elf?
   __DYNAMIC = 0; ${STACKZERO+${STACKZERO}} ${SHLIB_PATH+${SHLIB_PATH}}  */}
${RELOCATING+${EXECUTABLE_SYMBOLS}}
/* end DYNAMIC_LINKING ] */

SECTIONS
{
  .text ${RELOCATING+ __section_alignment__ } : 
  {
    ${RELOCATING+ *(.init)}
    *(.text)
    ${RELOCATING+. = ALIGN(4);}

    /* collect constructors only for final links */
    ${RELOCATING+ 
	*(.ctor_head);
	*(.ctors);
	*(.ctor);
	LONG (0);

	*(.dtor_head);
	*(.dtors);
	*(.dtor);
	LONG (0);
    }

    /* .gnu.warning sections are handled specially by elf32.em.  */
    *(.gnu.warning)
    ${RELOCATING+ *(.fini)}
    /* ??? Why is .gcc_exc here?  */
    ${RELOCATING+ *(.gcc_exc)}
    ${RELOCATING+ etext = .;}
    /* Grouped section support currently must be explicitly provided for
	in the linker script.  */
    *(.text\$)
    *(.gcc_except_table)
  }

  .plt $LINKERSECTS : { *(.plt)	}

  .data ${RELOCATING+ BLOCK(__section_alignment__) } :
  {
    ${RELOCATING+ __data_start__ = . }; 
    *(.data)
    *(.data2)
    ${RELOCATING+ __data_end__ = . }; 
    /* Grouped section support currently must be explicitly provided for
	in the linker script.  */
    *(.data\$)
  }

  .rdata ${RELOCATING+ BLOCK(__section_alignment__) } :
  {
    *(.rdata)
    /* Grouped section support currently must be explicitly provided for
	in the linker script.  */
    *(.rdata\$)
    /* DYNAMIC_LINKING [ */
    *(.hash)
    *(.interp)
    /* ] */
  }

  .pdata ${RELOCATING+ BLOCK(__section_alignment__) } :
  {
    *(.pdata)
    ;
  }

/* if DYNAMIC_LINKING [ */
  .got         ${RELOCATING-0} ${RELOCATING+ BLOCK(__section_alignment__) } : { *(.got.plt) *(.got) }
/* end DYNAMIC_LINKING ] */

/* .idata must precede bss so file and code offsets remain the same for .sos */
/* (At least for now... using Ldr* routines may fix.) */
  .idata ${RELOCATING+ BLOCK(__section_alignment__) } :
  {
    /* This cannot currently be handled with grouped sections.
	See pe.em:sort_sections.  */
    *(.idata\$2)
    *(.idata\$3)
    *(.idata\$4)
    *(.idata\$5)
    *(.idata\$6)
    *(.idata\$7)
  }

  .bss ${RELOCATING+ BLOCK(__section_alignment__) } :
  {
    ${RELOCATING+ __bss_start__ = . };
/* DYNAMIC_LINKING */
    *(.dynbss)
/* end DYNAMIC_LINKING */
    *(.bss)
    *(COMMON)
    ${RELOCATING+ __bss_end__ = . };
  }

  .edata ${RELOCATING+ BLOCK(__section_alignment__) } :
  {
    *(.edata)
  }

  /DISCARD/ ${RELOCATING+ BLOCK(__section_alignment__) } :
  {
    *(.debug\$S)
    *(.debug\$T)
    *(.debug\$F)
    *(.drectve)
  }

  .CRT ${RELOCATING+ BLOCK(__section_alignment__) } :
  { 					
    /* Grouped sections are used to handle .CRT\$foo.  */
    *(.CRT\$)
  }
  .rsrc ${RELOCATING+ BLOCK(__section_alignment__) } :
  { 					
    /* Grouped sections are used to handle .rsrc\$0[12].  */
    *(.rsrc\$)
  }

  .endjunk ${RELOCATING+ BLOCK(__section_alignment__) } :
  {
    /* end is deprecated, don't use it */
    ${RELOCATING+ end = .;}
    ${RELOCATING+ __end__ = .;}
  }

/* DYNAMIC_LINKING [ */
  .dynamic     ${RELOCATING-0} ${RELOCATXXX+"(NOLOAD)"} : { *(.dynamic) }

  .dynsym $LINKERSECTS : { *(.dynsym)	}
  .dynstr $LINKERSECTS : { *(.dynstr)	}
  .gnu.version $LINKERSECTS : { *(.gnu.version)	}
  .gnu.version_d $LINKERSECTS : { *(.gnu.version_d)	}
  .gnu.version_r $LINKERSECTS : { *(.gnu.version_r)	}

  .rel.dyn    $LINKERSECTS :
  { 
    *(.rel.internal)
    *(.rel.got)
    *(.rel.plt)
  }
  .rela.dynamic   $LINKERSECTS :
    { *(.rela.*) }
  .init        $LINKERSECTS : { *(.init)	} =${NOP-0}
/* end DYNAMIC_LINKING ] */

  .reloc ${RELOCATING+ BLOCK(__section_alignment__) } :
  { 					
    *(.reloc)
  }

  .stab ${RELOCATING+ BLOCK(__section_alignment__) } ${RELOCATING+"(NOLOAD)"} : 
  {
    [ .stab ]
  }

  .stabstr ${RELOCATING+ BLOCK(__section_alignment__) } ${RELOCATING+"(NOLOAD)"} : 
  {
    [ .stabstr ]
  }

}
EOF
