/* Internal communication of headers and externs; even more private than
   symbols in link.h.  They'd be static if they were all in one file.

   Copyright (C) 1995, 1996 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

size_t _dl_global_scope_alloc;

extern int _dl_argc;
extern char **_dl_argv;
extern char **_environ;

extern int __libc_enable_secure;

char * _itoa(long number, char *bufend, int base, int uppercase);

void * _dl_malloc(int);
void * _dl_realloc(void *, int);
void   _dl_free(void *);
char * _dl_strdup(const char *);

void __dl_assert (const void *assertion, const void *file, unsigned int line);

#ifndef NDEBUG
#define	_dl_assert(expr) ((expr) ? (void)0 : __dl_assert(#expr, __FILE__, __LINE__))
#else
#define _dl_assert(expr)
#endif

extern void _dl_main (VMA progLoadAddr, int startmode, VMA *startaddr);

struct link_map *_dl_load_target_shared_library 
   ( const char *, int, char *, struct link_map *, int);

#define __SUPPRESS_ERRNO
#include <errno.h>
extern int *_dl_perrno;
#define errno (*_dl_perrno)

/* Called in the static case for initialization. */
void _dl_static_init(void);
