/* Operating system support for run-time dynamic linker.  Generic Unix version.
   Copyright (C) 1995, 1996, 1997 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* This file contains utility functions (that don't fit nicely elsewhere)
   but which are not architecture dependent. */

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdarg.h>
#include <string.h>

#include "syscall.h"

/* Read the whole contents of FILE into new mmap'd space with given
   protections.  *SIZEP gets the size of the file.  */

char * _itoa(long number, char *bufend, int base, int uppercase)
{
    static const char lits[]="0123456789abcdefghijklmnopqrstuvwxyz";
    int sign;

    if (number == 0)
      {
	 *--bufend = '0';
	 return bufend; 
      }

    sign = (number < 0);
    if (sign)
        number = -number;
    while (number != 0)
      {
          *--bufend=lits[number%base];
	  number=number/base;
      }
    if (sign)
       *--bufend = '-';
    return bufend;
}

