/* Rename various functions to their real names.

   Copyright (C) 2000 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* Rename various system calls; the calls are macro-ized, and the rename to
   the real thing is localized here. */

#define _dl_sys_close close
#define _dl_sys_open open
#define _dl_sys_read read
#define _dl_sys_mprotect __sys_mprotect
#define _dl_sys_fstat fstat
#define _dl_sys_mmap mmap
#define _dl_sys_write write
#define _dl_sys_getuid getuid
#define _dl_sys_geteuid geteuid
#define _dl_sys_getgid getgid
#define _dl_sys_getegid getegid

void _exit(int) __attribute__ ((__noreturn__));

/* Some library functions get similar treatment to skip weak symbols. */
#define strcat _strcat
#define strncpy _strncpy
#define memcpy _memcpy
#define memset _memset
#define strpbrk _strpbrk
#define strchr _strchr
#define strcmp _strcmp
#define strncmp _strncmp
#define strlen _strlen
#define sigsetjmp _sigsetjmp
#define siglongjmp _siglongjmp

#define _dl_strncmp _strncmp
#define _dl_strcmp _strcmp

#define __alloca __builtin_alloca  /* comes from libgcc.a */

#define __set_errno(x) errno = x;

#define TARGET_TARGET "ix86"
#define TARGET_UNDERSCORE

#define PAGESZ 4096

#define RELOCATE_BOOTSTRAP_LOADER
