/* Copyright (C) 2000 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <stdio.h>

extern int g1;
extern int g2;
int g3;
int g4=0xd0;
int g5;  /* common.. no explicit definition */

long foo();
long thisisalongname();

/* Minimal prototype for proving feasability of shared libs */

main(int argc, char **argv)
{
   long res;

   fprintf(stderr, "starting main\n");

   fprintf(stderr, "init global var is %p %p %p %p %p\n", g1, g2, g3, g4, g5);

   g1 = 0xa1;
   g2 = 0xb1;
   g3 = 0xc1;
   g4 = 0xd1;
   g5 = 0xe1;
   fprintf(stderr, "global var is %p %p %p %p %p\n", g1, g2, g3, g4, g5);

   res = foo();
   fprintf(stderr, "foo's result is %d\n", res);
   fprintf(stderr, "global var is %p %p %p %p %p\n", g1, g2, g3, g4, g5);

   res = thisisalongname();
   fprintf(stderr, "thisisalongname's result is %d\n", res);
   fprintf(stderr, "global var is %p %p %p %p %p\n", g1, g2, g3, g4, g5);

   callrand();

   exit(0);
}

withmain()
{
   fprintf(stderr, "got to withmain()\n");
}
