/* Copyright (C) 2000 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <stdio.h>
#ifndef _ALL_SOURCE
#define _ALL_SOURCE
#endif
#include <dlfcn.h>

main(int argc, char **argv)
{
       void *libc;
       int retVal;
       int (*printf_call)();
       Dl_info info;

       retVal=0;

       fprintf(stderr, "Got %d args; argv[0] = %s\n", argc, argv[0]);
       if (argc > 1) {
	 fprintf(stderr, "            argv[1] = %s\n", argv[1]);
       }

       if(libc=dlopen("./testcase1.so",RTLD_LAZY)) {
         printf_call=dlsym(libc,"myprint");

	 if (printf_call == NULL)  {
	    printf("Lookup of symbol failed: %s\n", dlerror());
	 }
	 else
            retVal = (*printf_call)("hello, world\n");
         printf("retVal is %d\n", retVal);
       }
       else {
	 printf("Load of library failed: %s\n", dlerror());
       }

       if (dladdr((void *)printf_call+13, &info)) {
	 printf("symbol found near *printf_call is %s\n", info.dli_sname);
	 if ((long)printf_call != (long)info.dli_saddr)
	    printf("The addresses %p and %p do not match\n", 
	       printf_call, (long)info.dli_saddr);
       }
       else {
	 printf("symbol near myprint not found\n");
       }

       exit(0);
}
