/* Copyright (C) 2000 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <stdio.h>
#include <dlfcn.h>
#ifdef AIX
#include <sys/ldr.h>
#endif

main(int argc, char *argv[])
{
    int rc;
    int (*fptr)(int);
    void *dlthing;
    int i;

    dlthing = dlopen("./nosuch.so", RTLD_NOW);
    if (dlthing == NULL) {
        fprintf(stderr, "%s\n",dlerror());
	fprintf(stderr,"An open error should have been printed above\n\n");
    }

    fptr = (int(*)(int)) dlsym(dlthing, "dynLoadedEntryPoint");
    if (fptr == NULL) {
        fprintf(stderr, "%s\n",dlerror());
	fprintf(stderr,"A search error should have been printed above\n\n");
    }

    /* dynamically load the routine to be called */
    dlthing = dlopen("./testcase2a.so", RTLD_NOW);
    if (dlthing == NULL) {
        fprintf(stderr, "%s\n",dlerror());
        exit(1);
    }

    fptr = (int(*)(int)) dlsym(dlthing, "noSuchName");
    if (fptr == NULL) {
        fprintf(stderr, "%s\n",dlerror());
	fprintf(stderr,"A search error should have been printed above\n\n");
    }

    fptr = (int(*)(int)) dlsym(dlthing, "dynLoadedEntryPoint");
    if (fptr == NULL) {
        fprintf(stderr, "%s\n",dlerror());
        fprintf(stderr, "dlsym called failed\n");
        exit(1);
    }

    for (i = 0; i < 2; i++ ) {
        /* call the dynamically loaded routine */
        rc = (*fptr)(i);
        printf("...got back rc=%d from dynLoadedEntryPoint\n", rc);
    }

    /* unload the dynamically loaded routine */
    dlclose(dlthing);

    /* dynamically load the routine to be called */
    dlthing = dlopen("./testcase2b.so", RTLD_NOW);
    if (dlthing == NULL) {
        fprintf(stderr, "%s\n",dlerror());
        exit(1);
    }

    fptr = (int(*)(int)) dlsym(dlthing, "dynLoadedEntryPoint");
    if (fptr == NULL) {
        fprintf(stderr, "%s\n",dlerror());
        fprintf(stderr, "dlsym called failed\n");
        exit(1);
    }

    for (i = 0; i < 2; i++ ) {
        /* call the dynamically loaded routine */
        rc = (*fptr)(i);
        printf("...got back rc=%d from second dynLoadedEntryPoint\n", rc);
    }

    return 0;
}
